package com.holmos.cache;

/**
 * 创建缓存对象的工厂类
 * 
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
public final class HolmosCacheFactory {
	public static HolmosCache createMemoryCache(){
		return new HolmosMemoryCache();
	}
	public static HolmosCache createDiskCache(){
		return new HolmosDiskCache();
	}
	public static HolmosCache createCache(String cacheClassName){
		try {
			Class.forName(getFullClassName(cacheClassName)).newInstance();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static String getFullClassName(String className){
		for(String fullClassName:HolmosCacheManager.getInstance().getAllSubCacheNames())
			if(fullClassName.endsWith(className))
				return fullClassName;
		return null;
	}
}
