package com.holmos.cache;

import java.util.List;

import com.holmos.cache.data.HolmosCacheData;
import com.holmos.cache.data.HolmosDataResult;
import com.holmos.cache.data.HolmosResultCode;
import com.holmos.cache.state.HolmosCacheState;

public final class HolmosMemoryCache extends HolmosAbstractCache{
	
	public HolmosMemoryCache(){
		super();
	}
	/**当对缓存进行扩展的时候需要加上这句话，那么在写配置文件的时候就直接写上自己的实现就行，主要新的缓存类名不要有重复的*/
	static{
		HolmosCacheManager.getInstance().addSubClassName("com.holmos.cache.HolmosMemoryCache");
	}
	@Override
	public byte getLevel() {
		return 0;
	}

	@Override
	public String getCacheName() {
		return cacheConfig.getName();
	}

	@Override
	public HolmosResultCode putData(HolmosCacheData data) {
		HolmosResultCode result=cacheStore.putData(data);
		return result;
	}

	@Override
	public HolmosResultCode putBatchData(List<HolmosCacheData> data) {
		HolmosResultCode result=cacheStore.putBatchData(data);
		return result;
	}

	@Override
	public HolmosResultCode removeData(Object key) {
		return cacheStore.removeData(key);
	}

	@Override
	public HolmosResultCode removeBatchData(List<? extends Object> keys) {
		return cacheStore.removeBatchData(keys);
	}

	@Override
	public HolmosDataResult<HolmosCacheData> getData(Object key) {
		return cacheStore.getData(key);
	}

	@Override
	public HolmosDataResult<List<HolmosCacheData>> getBatchData(
			List<? extends Object> keys) {
		return cacheStore.getBatchData(keys);
	}

	@Override
	public HolmosResultCode lock(Object key) {
		return cacheStore.lock(key);
	}

	@Override
	public HolmosResultCode unlock(Object key) {
		return cacheStore.unlock(key);
	}

	@Override
	public HolmosResultCode mlock(List<? extends Object> keys) {
		return cacheStore.mlock(keys);
	}

	@Override
	public HolmosResultCode munlock(List<? extends Object> keys) {
		return cacheStore.munlock(keys);
	}

	@Override
	public HolmosResultCode clear(boolean quick) {
		return cacheStore.clear(quick);
	}

	@Override
	public HolmosCacheState getCacheState() {
		return cacheStore.getCacheState();
	}

	@Override
	public HolmosResultCode removeExpireData(boolean quick) {
		HolmosResultCode result= cacheStore.removeExpireData(quick);
		return result;
	}

	@Override
	public HolmosResultCode addItems(Object key, List<? extends Object> items,
			int offset, int maxCount) {
		HolmosResultCode result=cacheStore.addItems(key, items, offset, maxCount);
		return result;
	}

	@Override
	public HolmosResultCode removeItems(Object key, int offset, int count) {
		return cacheStore.removeItems(key, offset, count);
	}

	@Override
	public HolmosDataResult<HolmosCacheData> getAndRemove(Object key,
			int offset, int count) {
		return cacheStore.getAndRemove(key, offset, count);
	}

	@Override
	public HolmosResultCode removeDeletedData() {
		return cacheStore.removeDeletedData();
	}
}
