package com.holmos.cache.config;


/**
 * Watsen 平台缓存系统配置文件类，一个配置文件读取一个缓存的配置信息
 * 
 * @author 吴银龙(sunshine307087558@gmail.com)
 * 
 * */
public class HolmosCacheConfig {
	/**缓存的名字*/
	private String name;
	
	/**缓存的最大大小，超过这个大小，就得先对缓存进行部分无效*/
	private long maxSize;
	
	/**缓存数据移除策略*/
	private String outPolicy;
	
	/**缓存类型*/
	private String cacheType;
	
	/**缓存数据默认的生存时间*/
	private long liveTime;
	
	/**更新缓存时间间隔,单位毫秒*/
	private long updateCacheInterval;

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public long getMaxSize() {
		return maxSize;
	}

	public void setMaxSize(long maxSize) {
		this.maxSize = maxSize;
	}

	public String getOutPolicy() {
		return outPolicy;
	}

	public void setOutPolicy(String outPolicy) {
		this.outPolicy = outPolicy;
	}

	public String getCacheType() {
		return cacheType;
	}

	public void setCacheType(String cacheType) {
		this.cacheType = cacheType;
	}

	public long getUpdateCacheInterval() {
		return updateCacheInterval;
	}

	public void setUpdateCacheInterval(long updateCacheInterval) {
		this.updateCacheInterval = updateCacheInterval;
	}
	
	/**
	 * 获取此缓存的描述信息
	 * */
	public String toString(){
		StringBuilder info=new StringBuilder();
		info.append("缓存 "+name+" 的信息如下:\n");
		info.append("缓存类型:"+cacheType.toString()+"\n");
		info.append("缓存容量为:"+maxSize+"字节\n");
		info.append("缓存替换策略:"+outPolicy.toString()+"\n");
		info.append("缓存整理时间间隔:"+updateCacheInterval+"ms\n");
		return info.toString();
	}

	public long getLiveTime() {
		return liveTime;
	}

	public void setLiveTime(long liveTime) {
		this.liveTime = liveTime;
	}
}
