package com.holmos.cache.config.parser;

import java.util.ArrayList;
import java.util.HashMap;

import com.holmos.cache.config.HolmosCacheConfig;

/**
 * Watsen 平台的配置解析器接口，通过扩展可以实现对不同文件格式的解析，该平台实现properties和xml文件的解析
 * 
 * @author 吴银龙(sunshine307087558@gmail.com)
 * 
 * */
public abstract class AbstractParser {
	protected static String name="cache.names";
	protected static String maxSize="maxSize";
	protected static String outPolicyType="outPolicyType";
	protected static String type="type";
	protected static String updateInterval="updateInterval";
	protected static String liveTime="liveTime";
	
	protected HashMap<String,HolmosCacheConfig> configs=new HashMap<String, HolmosCacheConfig>();
	public AbstractParser(){
		
	}
	/**
	 * 将配置文件中名字为cacheName的缓存配置解析成{@link HolmosCacheConfig}
	 * 
	 * @param cacheName 要解析的缓存名字
	 * @return 解析生成的{@link HolmosCacheConfig}对象
	 * */
	public abstract HolmosCacheConfig parser(String cacheName);
	
	/**
	 * 解析配置文件中所有的缓存信息
	 * 
	 * @return 返回配置文件中所有的缓存配置信息
	 * 
	 * */
	public abstract ArrayList<HolmosCacheConfig> parserAll();
}
