package com.holmos.cache.constvalue;

import java.io.FileInputStream;
import java.util.Properties;

import com.holmos.cache.exception.HolmosCacheException;

/**
 * Watsen 平台缓存系统常数列表
 * 
 * @author 吴银龙(sunshine307087558@gmail.com)
 * 
 * */
public class CacheConstValue {
	
	/**缓存系统Properties格式的配置文件信息*/
	public static Properties PROCACHECONF=new Properties();
	

	/** Store初始容量，10000 */
    public static final int    STORE_INIT_CAPACITY     = 10000;

    /** Store加载因子，0.75 */
    public static final float  STORE_LOAD_FACTOR       = 0.75f;

    /** Store并发级别，100 */
    public static final int    STORE_CONCURRENCY_LEVEL = 100;
    
    /** 淘汰策略若按照数量来计算，一次淘汰的数据量,默认1000条数据*/
    public static final int    STORE_ONCE_WEEDOUTCOUNT = 1000;
    
    /** 淘汰策略若按照大小来计算，一次淘汰的数据大小  默认10MB*/
    public static final int    STORE_ONCE_WEEDOUTSIZE = 10000000;
    
	static{
		try {
			PROCACHECONF.load(new FileInputStream(System.getProperty("user.dir")+"\\conf\\cacheconf.properties"));
		} catch (Exception e) {
			throw new HolmosCacheException("缓存系统读取配置文件失败!");
		}
	}
}
