package com.holmos.cache.outpolicy;

import java.util.Random;

import com.holmos.cache.constvalue.CacheConstValue;
import com.holmos.cache.data.HolmosCacheData;
import com.holmos.cache.store.HolmosCacheStore;

/**
 * 元素删除策略：暂时的方法有：
 * 
 * <li>先进先出，FIFO</li>
 * <li>最近最少使用LRU，默认的</li>
 * <li>最不经常使用LFU</li>
 * */
public abstract class HolmosAbstractCacheOutPolicy {
	
	protected HolmosCacheStore cacheStore; 
	
	public HolmosAbstractCacheOutPolicy(HolmosCacheStore cacheStore){
		this.cacheStore=cacheStore;
	}
	
	/**
	 * 按照指定的淘汰规则淘汰数据
	 * */
	public void getWeedOutDatas(){
		Random ran=new Random(System.currentTimeMillis());
		long weedOutCount=CacheConstValue.STORE_ONCE_WEEDOUTCOUNT>cacheStore.getStoreSize()?
				cacheStore.getStoreSize()/100:CacheConstValue.STORE_ONCE_WEEDOUTCOUNT;
		int left,right;
		if(cacheStore.getStoreElementsCount()==1){
			cacheStore.clear(false);return;
		}
		for(int i=0;i<weedOutCount;i++){
			left=right=ran.nextInt((int) cacheStore.getStoreSize());
			while(right==left)
				right=ran.nextInt((int) cacheStore.getStoreSize());
			cacheStore.removeData(compare(left,right).getKey());
		}
	}

	public abstract HolmosCacheData compare(int left, int right);
}
