package com.holmos.cache.outpolicy;

import java.util.ArrayList;

/**
 * 缓存元素替换策略管理器
 * 
 * @author 吴银龙(sunshine307087558@gmail.com)
 * 
 * */
public class HolmosCacheOutPolicyManager {
	private HolmosCacheOutPolicyManager(){
		outPolicyClassNames=new ArrayList<String>();
	}
	private ArrayList<String> outPolicyClassNames=new ArrayList<String>();
	
	private volatile static HolmosCacheOutPolicyManager outPolicyManager=null;
	
	public static HolmosCacheOutPolicyManager getInstance(){
		if(null==outPolicyManager){
			synchronized (outPolicyManager) {
				if(null==outPolicyManager)
					outPolicyManager=new HolmosCacheOutPolicyManager();
			}
		}
		return outPolicyManager;
	}
	public void addOutPolicyClassName(String outPolicyClassName){
		this.outPolicyClassNames.add(outPolicyClassName);
	}
	public void removeOutPolicyClassName(String outPolicyClassName){
		this.outPolicyClassNames.remove(outPolicyClassName);
	}
	public ArrayList<String> getAllFullOutPolicyClassNames(){
		return this.outPolicyClassNames;
	}
}
