package com.holmos.cache.outpolicy;

import java.util.ArrayList;

import com.holmos.cache.data.HolmosCacheData;
import com.holmos.cache.store.HolmosCacheStore;

public final class HolmosFIFOOutPolicy extends HolmosAbstractCacheOutPolicy{
	
	public HolmosFIFOOutPolicy(HolmosCacheStore cacheStore) {
		super(cacheStore);
	}

	static{
		HolmosCacheOutPolicyManager.getInstance().addOutPolicyClassName(
				"com.holmos.cache.outpolicy.HolmosFIFOOutPolicy");
	}

	@Override
	public HolmosCacheData compare(int left, int right) {
		ArrayList<HolmosCacheData> data = cacheStore.getAllDatas();
		HolmosCacheData leftData= data.get(left),
				rightData=data.get(right);
		if(leftData.getCreatedTime()<=rightData.getCreatedTime())
			return leftData;
		return rightData;
	}

}
