package com.holmos.cache.outpolicy;

import java.util.ArrayList;

import com.holmos.cache.data.HolmosCacheData;
import com.holmos.cache.store.HolmosCacheStore;

/**
 * 最不经常使用淘汰策略
 * 
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
public final class HolmosLFUOutPolicy  extends HolmosAbstractCacheOutPolicy{
	public HolmosLFUOutPolicy(HolmosCacheStore cacheStore) {
		super(cacheStore);
	}

	static{
		HolmosCacheOutPolicyManager.getInstance().addOutPolicyClassName(
				"com.holmos.cache.outpolicy.HolmosLFUOutPolicy");
	}

	@Override
	public HolmosCacheData compare(int left, int right) {
		ArrayList<HolmosCacheData> data = cacheStore.getAllDatas();
		HolmosCacheData leftData= data.get(left),
				rightData=data.get(right);
		if(leftData.getLastVisitTime()<rightData.getLastVisitTime())
			return leftData;
		return rightData;
	}
	
}
