
package com.holmos.cache.outpolicy;

import java.util.ArrayList;

import com.holmos.cache.data.HolmosCacheData;
import com.holmos.cache.store.HolmosCacheStore;

public final class HolmosLRUOutPolicy  extends HolmosAbstractCacheOutPolicy{
	public HolmosLRUOutPolicy(HolmosCacheStore cacheStore) {
		super(cacheStore);
	}

	static{
		HolmosCacheOutPolicyManager.getInstance().addOutPolicyClassName(
				"com.holmos.cache.outpolicy.HolmosLRUOutPolicy");
	}

	@Override
	public HolmosCacheData compare(int left, int right) {
		ArrayList<HolmosCacheData> data = cacheStore.getAllDatas();
		HolmosCacheData leftData= data.get(left),
				rightData=data.get(right);
		if(leftData.getVisitTimes()<rightData.getVisitTimes())
			return leftData;
		return rightData;
	}
}
