package com.holmos.cache.size.layout.sizegetter.impl;

import java.lang.reflect.Array;

import com.holmos.cache.size.DataDictionary;
import com.holmos.cache.size.layout.ClassSizeInfoParser;
import com.holmos.cache.size.layout.MemoryLayoutSpecification;
import com.holmos.cache.size.layout.sizegetter.SizeGetter;

public class ArraySizeGetter extends SizeGetter{

	public ArraySizeGetter(MemoryLayoutSpecification layoutSpecification) {
		super(layoutSpecification);
	}

	@Override
	public int getsize(Object value) {
		int size=DataDictionary.getInstance().getTypeSize(value.getClass());
		if(0 == size){
			size=ClassSizeInfoParser.getLayoutSpecification().getCommonFieldsSize(value.getClass());
			DataDictionary.getInstance().putTypeSize(value.getClass(), size);
		}
		int length=Array.getLength(value);
		final Class<?> componentType=value.getClass().getComponentType();
		if(length>0){
			//当数组里面有元素的时候，对里面元素进行计算
			if(componentType.isPrimitive())
				size+=getPrimitiveElementsSize(componentType,length);
			else
				size+=getRefrenceElementsSize(value,length);
		}
		return size;
	}
	
	private int getRefrenceElementsSize(Object value,int length){
		int size = getPrimitiveElementsSize(Object.class, length);//计算数组类型数据的对象引用大小
		for(int i=0;i<length;i++){
			Object element=Array.get(value, i);
			if(DataDictionary.getInstance().getUserNum(element)==0)
				size+=sizeGetter.getDataSize(element);
			DataDictionary.getInstance().addObjectUse(element);
		}
		return size;
	}
	
	private int getPrimitiveElementsSize(Class<?> componentType, int length) {
		int readOnceSize=ClassSizeInfoParser.getLayoutSpecification().getDataSizeOnce();
		int elementSize=ClassSizeInfoParser.getLayoutSpecification().getPrimitiveSize(componentType);
		int temp=readOnceSize/elementSize;//这个数字在这里就是一个临时变量，因为公式要用到它
		return (length+temp-1)/temp*readOnceSize;
	}

	@Override
	public boolean canGet(Object value) {
		if(null==value)
			return false;
		if(value.getClass().isArray())
			return true;
		return false;
	}

}
