package com.holmos.cache.size.layout.sizegetter.impl;

import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.ArrayList;

import com.holmos.cache.size.DataDictionary;
import com.holmos.cache.size.layout.MemoryLayoutSpecification;
import com.holmos.cache.size.layout.sizegetter.SizeGetter;

public class ObjectSizeGetter extends SizeGetter{

	public ObjectSizeGetter(MemoryLayoutSpecification layoutSpecification) {
		super(layoutSpecification);
	}

	@Override
	public int getsize(Object value) {
		int size=DataDictionary.getInstance().getTypeSize(value.getClass());
		if(0 == size){
			size += getStaticPrimitiveElementSize(value);
			size += getStaticRefrenceElementSize(value);
			size += getCommenPrimitiveElementSize(value);
			DataDictionary.getInstance().putTypeSize(value.getClass(), size);
		}
		size += getCommonRefrenceFieldsSize(value);
		return size;
	}

	private int getStaticRefrenceElementSize(Object value) {
		return getRefrenceFieldsSize(getStaticRefrenceFields(value), value);
	}

	private int getStaticPrimitiveElementSize(Object value) {
		return layoutSpecification.getStaticFieldsSize(value.getClass());
	}

	private int getCommenPrimitiveElementSize(Object value){
		return layoutSpecification.getCommonFieldsSize(value.getClass());
	}
	private int getCommonRefrenceFieldsSize(Object value){
		return getRefrenceFieldsSize(getCommonRefrenceFields(value), value);
	}
	
	private int getRefrenceFieldsSize(ArrayList<Field> fields,Object value){
		int size=0;
		try{
			for(Field field:fields){
				Object element = field.get(value);
				if(DataDictionary.getInstance().getUserNum(element)==0){
					size += sizeGetter.getDataSize(element);
				}
				DataDictionary.getInstance().addObjectUse(element);
			}
		}catch(Exception e){}
		return size;
	}
	
	private ArrayList<Field> getCommonRefrenceFields(Object value){
		ArrayList<Field> refFields=new ArrayList<Field>();
		for(Field field : getCommonElements(value))
			if(!field.getType().isPrimitive()&&(field.getModifiers() & Modifier.STATIC) ==0)
				refFields.add(field);
		return refFields;
	}
	
	private ArrayList<Field> getStaticRefrenceFields(Object value){
		ArrayList<Field> refFields=new ArrayList<Field>();
		for(Field field : getCommonElements(value))
			if(!field.getType().isPrimitive()&&(field.getModifiers() & Modifier.STATIC) !=0)
				refFields.add(field);
		return refFields;
	}
	
	@Override
	public boolean canGet(Object value) {
		if(null==value)
			return false;
		return true;
	}

}
